<?= $element->renderSubmenu('/8-lekce-prace-se-session'); ?>

<h1 class="mainTitle"><?= $template->title; ?></h1>

<p>
	Posledně jsme si ukázali jak se pracuje s formuláři. Možná jste si zkusili zpracovávat formulář v jiném souboru.
	Pokud uživatel odeslal formulář se správnými údaji, tak bylo vše v pořádku. Co když ale vyplnil například e-mail ve špatném tvaru?
	Určitě jste uživatele přesměrovali zpět na formulář. Ale jak mu zobrazit data, která odeslal?<br>
	Právě pro tyto situace nám slouží <b class="text-pink-dark">Session</b>.
</p>

<p>Další a stejně často používanou variantou je ukládání informace o přihlášeném uživateli nebo informace o produktech, které máte v košíku.</p>

<h2 class="text-xl">Co je Session a jak funguje</h2>

<p>
	Session je textový soubor, který se ukládá na serveru (tam kde je web, ve "skryté" složce). Pro každého návštěvníka webu se vytvoří jeden soubor.
	A vždy když je návštěvník na kterékoli stránce Vašeho webu, tak PHP si tento soubor načte a Vy (programátoři) máte přístup k datům tohoto souboru.
</p>

<p>Do <b>Session</b> můžete uložit cokoli. Co tam uložíte, to tam najdete.</p>

<p>
	No ale <b>Session</b> je uložena na serveru. Jak se k ní PHP dostane?<br>
	Aby Session mohlo fungovat, využívá <b>Cookies</b>.
	<b class="text-pink-dark">Cookies</b> je naopak malý textový (max. velikost 4kB) soubor uložený v prohlížeči. A v tomto <b>Cookies</b> souboru je uložen název <b>Session</b> souboru, který má PHP načíst.
	Proto když například smažete historii prohlížeče, tak ve svém oblíbeném e-shopu se Vám vymaže obsah košíku s produkty, které jste si ještě nekoupili, ale přidali do košíku.
</p>


<h2 class="text-xl" id="nastaveni-session">Zapnutí session</h2>

<p>Dříve než začneme v PHP pracovat se Session, tak ji musíme zapnout.</p>

<pre class="php">
&lt;?php
    <span class="php__fun">session_start</span>();
?&gt;
</pre>

<p>Ideálně tedy dát někde na začátek našeho souboru. <span class="font-bold">Pokud máme více souborů a v každém chceme pracovat se session, musí session nastartovat v každém souboru ve kterém se session pracujeme.</span></p>

<p>
	Pokud to ale není nutné nebo nechceme session zapínat vždy, případně nevíme zda je nebo není zapnutá (<b>session_start</b> se
	totiž nesmí volat během jednoho požadavku vícekrát), využijeme následující podmínky. <a href="https://www.php.net/manual/en/function.session-status.php" target="_blank">Dokumentace</a>.
</p>

<pre class="php">
&lt;?php
    <span class="php__syntax">if</span> (<span class="php__fun">session_status</span>() === <span class="php__num">PHP_SESSION_NONE</span>) {
        <span class="php__fun">session_start</span>();
    }
?&gt;
</pre>

<p>Nějaké zdroje o session a především o zabezpečení session:</p>
<ul>
	<li><a href="https://www.interval.cz/clanky/zaciname-pouzivat-sessions-v-php/" target="_blank">interval.cz</a></li>
	<li><a href="https://www.php.net/manual/en/session.security.ini.php" target="_blank">php.net</a></li>
	<li><a href="http://www.phpguru.cz/clanky/predavani-sid-pomoci-cookies" target="_blank">phpguru.cz</a></li>
	<li><a href="https://www.kutac.cz/blog/weby-a-vse-okolo/bezpecnost-a-expirace-sessions-v-php/" target="_blank">kutac.cz</a></li>
	<li><span class="link" data-open-code="session-settings">rychlý výcuc</span></li>
</ul>

<div class="hidden" data-open-code-id="session-settings">
<pre class="php">
&lt;?php
    <span class="php__fun">ini_set</span>(<span class="php__str">'session.use_cookies'</span>, <span class="php__num">1</span>); <span class="php__comment">// používání cookies</span>
    <span class="php__fun">ini_set</span>(<span class="php__str">'session.use_only_cookies'</span>, <span class="php__num">1</span>); <span class="php__comment">// používání pouze cookies</span>
    <span class="php__fun">ini_set</span>(<span class="php__str">'session.use_trans_sid'</span>, <span class="php__num">0</span>); <span class="php__comment">// identifikátory session nebusou přenášeny ani čteny z URL</span>
    <span class="php__fun">ini_set</span>(<span class="php__str">'session.use_strict_mode'</span>, <span class="php__num">1</span>); <span class="php__comment">// přijme pouze serverem generované session</span>
    <span class="php__fun">ini_set</span>(<span class="php__str">'session.cookie_lifetime'</span>, <span class="php__num">0</span>); <span class="php__comment">// expirace cookies do zavření prohlížeče</span>
    <span class="php__fun">ini_set</span>(<span class="php__str">'session.cookie_domain'</span>, <span class="php__str">''</span>); <span class="php__comment">// ovlivňuje viditelnost session mezi doménami</span>
    <span class="php__fun">ini_set</span>(<span class="php__str">'session.cookie_httponly'</span>, <span class="php__syntax">TRUE</span>); <span class="php__comment">// session je dostupná pouze přes http</span>
    <span class="php__fun">ini_set</span>(<span class="php__str">'session.cookie_secure'</span>, <span class="php__syntax">FALSE</span>); <span class="php__comment">// posílání session pouze přes https</span>

    <span class="php__fun">session_start</span>();
?&gt;
</pre>
</div>


<h2 class="mainTitle" id="session">Práce se Session</h2>

<p>
	Session je serverová proměnná <b class="text-pink-dark">$_SESSION</b>. Dokud do ní nic nedáme, tak "neexistuje". Když do ní přiřadíme řetězec, bude tam pouze tento řetězec.
	V reálném světě ale potřebujeme "přenášet" více informací, proto se <b>Session</b> používá jako pole.
</p>


<h3 class="text-xl">Přiřazení hodnoty do Session</h3>

<pre class="php">
&lt;?php
    <span class="php__obj">$_SESSION</span>[<span class="php__str">'FORMULAR'</span>][<span class="php__str">'jmeno'</span>] = <span class="php__fun">filter_input</span>(<span class="php__num">INPUT_POST</span>, <span class="php__str">'jmeno'</span>, <span class="php__num">FILTER_SANITIZE_SPECIAL_CHARS</span>);
?&gt;
</pre>


<h3 class="text-xl">Získání hodnoty ze Session</h3>

<pre class="php">
&lt;?php
    <span class="php__var">$formularJmeno</span> = <span class="php__obj">$_SESSION</span>[<span class="php__str">'FORMULAR'</span>][<span class="php__str">'jmeno'</span>];
?&gt;
</pre>


<h3 class="text-xl">Smazání Session</h3>
<pre class="php">
&lt;?php
    <span class="php__comment">// smazání konkrétní hodnoty ze Session</span>
    <span class="php__fun">unset</span>(<span class="php__obj">$_SESSION</span>[<span class="php__str">'FORMULAR'</span>][<span class="php__str">'jmeno'</span>]);

    <span class="php__comment">// smazání celé Session</span>
    <span class="php__fun">unset</span>(<span class="php__obj">$_SESSION</span>);

    <span class="php__comment">// smazání celé Session pomocí systémové funkce</span>
    <span class="php__fun">session_unset</span>();
?&gt;
</pre>